#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "config.h"
#include "interface.h"
#include "support.h"
#include "system.h"
#include "bzip.h"
char *bzipexe;
float bziplen=0;
void bzipCompress(char *saveas){
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  if(methods.bzip.Intern==1)
	internBzip(saveas);
  else
	externBzip(saveas);
}

void bzipParseOptions(){
  bzipexe=(char*)malloc(2048);
  memset(bzipexe,0x0,sizeof(bzipexe));
//  strcpy(bzipexe,methods.bzip.Exe);
  strcpy(bzipexe,"-");
  if(methods.bzip.Store==1)
	strcat(bzipexe,"0");
  else{
	char *temp;
	temp=(char*)malloc(sizeof(temp));
	sprintf(temp,"%d",methods.bzip.CompLevel);
	strcat(bzipexe,temp);
	free(temp);
  }
  if(methods.bzip.ForceComp==1)
	strcat(bzipexe,"z");
  if(methods.bzip.KeepInput==1)
	strcat(bzipexe,"k");
  if(methods.bzip.WriteOverOut==1)
	strcat(bzipexe,"f");
  if(methods.bzip.RedMem==1)
	strcat(bzipexe,"s");
}

void externBzip(char *saveas){
  FILE *fp;
  char *buffer,*exe[8194];
  char temp2[256];
  int status=0;
  float nums=0,size=0;
  nums=selTo->numrows;
  gdk_threads_enter();
  lstTo=lookup_widget(winMain,"lstTo");
  for(bziplen=0;;bziplen++){
	if(cancelled==1)
	  break;
	if(gtk_clist_get_text(GTK_CLIST(lstTo),bziplen,0,&buffer)==0)
  	  break;
  	else{
  	  fp=fopen(buffer,"r");
  	  fseek(fp,0L,SEEK_END);
  	  size=ftell(fp);
  	  fclose(fp);
	  gtk_progress_configure(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),0,0,size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/6);
  	  while(gtk_events_pending())
        gtk_main_iteration();
  	  bzipParseOptions();
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/5);
  	  while(gtk_events_pending())
  	    gtk_main_iteration();
  	  exe[0]=methods.bzip.Exe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/4);
  	  while(gtk_events_pending())
        gtk_main_iteration();
  	  exe[1]=bzipexe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
  	  while(gtk_events_pending())
        gtk_main_iteration();
	  exe[2]=buffer;
      gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/2);
      while(gtk_events_pending())
    	gtk_main_iteration();	
  	  status=mySystem(exe);
//	  printf("status %d\n",status);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),bziplen);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),buffer);
  	  memset(temp2,0x0,sizeof(temp2));
  	  sprintf(temp2,"%1.0f of %1.0f done",bziplen+1,nums);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressTotalFiles")),temp2);
  	  while(gtk_events_pending())
        gtk_main_iteration();
	}
  }
  if(cancelled==1){
//	printf("Cancelled\n");
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG08,strlen(ERR_MSG08));
	gtk_widget_show(errMessage);
  }else{
	if(methods.bzip.TestInt==1){
	  memset(exe,0x0,sizeof(exe));
	  exe[0]=methods.bzip.Exe;
	  exe[1]="-t";
	  exe[2]=saveas;
	  status=mySystem(exe);
	  printf("%d\n",status);
	  if(status==512){
		gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG02,strlen(GZERR_MSG02));
		gtk_widget_show(errMessage);
	  }else{
		gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size+=10);
		gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),"Testing the archive");
		while(gtk_events_pending())
  	  	  gtk_main_iteration();	
		gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG03,strlen(GZERR_MSG03));
		gtk_widget_show(errMessage);
	  }
	}
	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),bziplen+1);
	while(gtk_events_pending())
  	  gtk_main_iteration();	
	gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
	gtk_widget_show(lookup_widget(Progress,"btnProgressClose"));
	gtk_widget_grab_default(lookup_widget(Progress,"btnProgressClose"));
//  gtk_clist_remove(GTK_CLIST(lstTo),bziplen);
	gdk_threads_leave();
  }
}

int internBzip(char *saveas){
  return 0;
}  
